<script type="text/javascript">
	/*globals RED */
	RED.nodes.registerType('Storage Read', {
		category: 'storage',
		color: '#fdeea2',
		defaults: {
			name: {value:null},
			key: {value:"topic"},"key-type": {value:"msg"},
			storageDefinition: {type:"Storage Definition"},
			target: {value:"payload"},"target-type": {value:"msg"}
		},
		inputs: 1,
		outputs: 2,
		icon: "icons8-ibooks-96.png",
		align: 'left',
		paletteLabel: "Storage Read",
		inputLabels: "Message In",
		outputLabels: ["Message Out","Error"],
		label: function () {
			const name=RED.nodes.node(this.storageDefinition).name;
			return this.name ||"Storage Read "+ (name||this.storageDefinition);
		},
		oneditprepare: function() {
			const node=this;
			node.properties=[];
			node.editors=[];
			const actions={
//				blockStorage:{label:"Block Storage",show:["fileName"],args:[]}
			};
			const baseDiv=$("#node-inputDynamicBase");
			function defineProperty(property,...types) {
				const element=$('<div/>',{ "class": "form-row form-row-http-in-"+property.name+" hide" }).append(
    				 	$('<label for="node-input-'+property.name+'" style="white-space: nowrap"><i class="fa fa-'+(property.icon||'bookmark')+'"></i> '+property.label+'</label>'),
					);
				element.appendTo(baseDiv);
				node.properties.push(property.name);
				if(types[0]=="edit") {
					element.append($('<div style="height: 250px; min-height:150px;" class="node-text-editor" id="node-input-'+property.name+'-editor"></div>'));
					node.editors[property.name] = RED.editor.createEditor({
   						id: 'node-input-'+property.name+'-editor',
   						mode: 'ace/mode/'+property.mode||"text",
   						value: node[property.name]||property.default
					});
				} else {
					const inputNode=$('<input type="text" id="node-input-'+property.name+'"/>').val(node[property.name]);
					const typeNode=$('<input type="hidden" id="node-input-'+property.name+'-type"/>');
					element.append([inputNode,typeNode]);
					const typeValue=node[property.name+"-type"];
					if(typeValue) typeNode.val(typeValue);
					$("#node-input-"+property.name).typedInput({
	  					type:typeValue||types[0],
    					types:types,
    					typeField: "#node-input-"+property.name+"-type"
					});
				}
			}
			defineProperty({name:"target"			,label:"Target"	,icon:"tag"},"msg","flow","global");
			defineProperty({name:"key"				,label:"Key"	,icon:"tag"},"num","msg","flow","global");
			["target","key"].forEach(property=>$(".form-row-http-in-"+property).show());
/*
			const options=Object.keys(actions).reduce((previousValue,property)=>previousValue.concat({value:property,label:actions[property].label}),
				[]);
			const actionNode=$("#node-input-action");
			actionNode.typedInput({
    			types: [{
            		value: "actionType",
            		options: options
				}]
			});
			actionNode.change(function() {
				action=$(this).val();
				node.args=[];
				node.properties.forEach(property=>$(".form-row-http-in-"+property).hide());
				const actionDef=actions[action];
				node.args=actionDef.args;
				node.args.forEach(property=>$(".form-row-http-in-"+property).show());
				actionDef.show.forEach(property=>$(".form-row-http-in-"+property).show());

			});
*/
		},
		oneditsave: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
				node[property]=editor.getValue();
	    		editor.destroy();
    			delete editor;
			})
		},
		oneditcancel: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
    			editor.destroy();
    			delete editor;
			});
		},
		resizeRule: function(file,newWidth) {
		}
	});
</script>

<script type="text/x-red" data-template-name="Storage Read">

	<div class="form-row">
		<label for="node-input-name"><i class="fa fa-tag"></i> Name </label>
		<input type="text" id="node-input-name" placeholder="Name">
	</div>
	<div class="form-row">
		<label for="node-input-storageDefinition"><i class="fa fa-list-ul"></i> Storage </label>
		<input type="text" id="node-input-storageDefinition">
  	</div>
	<div id="node-inputDynamicBase"/>
</script>

<script type="text/x-red" data-help-name="Storage Read">
	<p>
	Storage Definition
	</p>
	<h3>Inputs</h3>
	<dl class="message-properties">
		<dt>msg <span class="property-type">topic</span></dt>
		<dd>incoming message with topic</dd>
		<dt>msg <span class="property-type">payload</span></dt>
		<dd></dd>
	</dl>
</script>